﻿Imports Telerik.WinControls
Imports Telerik.WinControls.UI
Imports Telerik.WinControls.Layouts

Public Class RadForm1
    Public Sub New()
        InitializeComponent()

        Dim timespanPicker As New RadTimeSpanPicker()
        Me.Controls.Add(timespanPicker)
        timespanPicker.Size = New System.Drawing.Size(200, 22)
        timespanPicker.Location = New Point(10, 10)
        timespanPicker.Value = New TimeSpan(12, 3, 45, 25, 200)
        AddHandler timespanPicker.TimeSpanPickerElement.ValueChanged, AddressOf timespanPicker_ValueChanged
    End Sub

    Private Sub timespanPicker_ValueChanged(sender As Object, e As ValueEventArgs)
        Me.radLabelElement1.Text = String.Format("Days:{0}, Hours:{1}, Minutes:{2}, Seconds:{3}, Miliseconds:{4}", e.Value.Days, e.Value.Hours, e.Value.Minutes, e.Value.Seconds, e.Value.Minutes)
    End Sub

    Public Class RadTimeSpanPicker
        Inherits RadControl

        Private m_timeSpanPickerElement As RadTimeSpanPickerElement
        Public Overrides Property ThemeClassName As String
            Get
                Return GetType(RadTimePicker).FullName
            End Get
            Set(value As String)
                MyBase.ThemeClassName = value
            End Set
        End Property

        Protected Overrides Sub CreateChildItems(parent As RadElement)
            MyBase.CreateChildItems(parent)
            m_timeSpanPickerElement = CreateTimeSpanPickerElement()
            parent.Children.Add(m_timeSpanPickerElement)

        End Sub

        Public ReadOnly Property TimeSpanPickerElement() As RadTimeSpanPickerElement
            Get
                Return Me.m_timeSpanPickerElement
            End Get
        End Property

        Protected Overridable Function CreateTimeSpanPickerElement() As RadTimeSpanPickerElement
            Return New RadTimeSpanPickerElement()
        End Function

        Public Property Separator() As String
            Get
                Return Me.TimeSpanPickerElement.Separator
            End Get
            Set(value As String)
                Me.TimeSpanPickerElement.Separator = value
            End Set
        End Property

        Public Property Value() As TimeSpan
            Get
                Return Me.TimeSpanPickerElement.Value
            End Get
            Set(value As TimeSpan)
                Me.TimeSpanPickerElement.Value = value
            End Set
        End Property
    End Class

    Public Class RadTimeSpanPickerElement
        Inherits RadElement
        Public Event ValueChanged As ValueChangedEventHandler
        Public Delegate Sub ValueChangedEventHandler(sender As Object, e As ValueEventArgs)
        Protected Overridable Sub OnValueChanged(e As ValueEventArgs)
            RaiseEvent ValueChanged(Me, e)
        End Sub

        Private dayTimeSpanComponent As RadSpinEditorElement
        Private hourTimeSpanComponent As RadSpinEditorElement
        Private minuteTimeSpanComponent As RadSpinEditorElement
        Private secondTimeSpanComponent As RadSpinEditorElement
        Private millisecondTimeSpanComponent As RadSpinEditorElement
        Private button As RadTimeDropDownButtonElement
        Private separator1 As RadLabelElement
        Private separator2 As RadLabelElement
        Private separator3 As RadLabelElement
        Private separator4 As RadLabelElement
        Private popup As RadDropDownMenu
        Private m_value As TimeSpan
        Private m_timeSpanComponentsContainer As StackLayoutPanel
        Private m_buttonsContainer As DockLayoutPanel
        Private shouldClose As Boolean = False

        Protected Overrides Sub CreateChildElements()
            MyBase.CreateChildElements()
            dayTimeSpanComponent = New RadSpinEditorElement()
            hourTimeSpanComponent = New RadSpinEditorElement()
            minuteTimeSpanComponent = New RadSpinEditorElement()
            secondTimeSpanComponent = New RadSpinEditorElement()
            millisecondTimeSpanComponent = New RadSpinEditorElement()
            button = New RadTimeDropDownButtonElement()
            separator1 = New RadLabelElement()
            separator2 = New RadLabelElement()
            separator3 = New RadLabelElement()
            separator4 = New RadLabelElement()
            m_timeSpanComponentsContainer = New StackLayoutPanel()
            m_buttonsContainer = New DockLayoutPanel()


            Dim container As New StackLayoutElement()
            container.Orientation = Orientation.Horizontal
            container.BackColor = Color.White
            container.StretchHorizontally = True
            container.DrawFill = True
            Me.Separator = ":"
            Me.PopupSize = New System.Drawing.Size(300, 200)
            Me.DaysStep = 1
            Me.DaysItemsCount = 30
            Me.HoursStep = 1
            Me.HoursItemsCount = 23
            Me.MinutesStep = 1
            Me.MinutesItemsCount = 59
            Me.SecondsStep = 1
            Me.SecondsItemsCount = 59
            Me.MilisecondsStep = 100
            Me.MilisecondsItemsCount = 9

            separator1.Text = Me.Separator
            separator1.LabelFill.BackColor = Color.White
            separator1.LabelFill.GradientStyle = GradientStyles.Solid
            separator2.Text = Me.Separator
            separator2.LabelFill.BackColor = Color.White
            separator2.LabelFill.GradientStyle = GradientStyles.Solid
            separator3.Text = Me.Separator
            separator3.LabelFill.BackColor = Color.White
            separator3.LabelFill.GradientStyle = GradientStyles.Solid
            separator4.Text = Me.Separator
            separator4.LabelFill.BackColor = Color.White
            separator4.LabelFill.GradientStyle = GradientStyles.Solid

            container.Children.Add(dayTimeSpanComponent)
            container.Children.Add(separator1)
            container.Children.Add(hourTimeSpanComponent)
            container.Children.Add(separator2)
            container.Children.Add(minuteTimeSpanComponent)
            container.Children.Add(separator3)
            container.Children.Add(secondTimeSpanComponent)
            container.Children.Add(separator4)
            container.Children.Add(millisecondTimeSpanComponent)

            popup = CreateDropDownForm()

            dayTimeSpanComponent.MinValue = 0
            dayTimeSpanComponent.DecimalPlaces = 0
            dayTimeSpanComponent.ShowUpDownButtons = False
            AddHandler dayTimeSpanComponent.ValueChanged, AddressOf dayTimeSpanComponent_ValueChanged
            AddHandler dayTimeSpanComponent.TextBoxItem.LostFocus, AddressOf TextBoxItem_LostFocus

            hourTimeSpanComponent.MinValue = 0
            hourTimeSpanComponent.DecimalPlaces = 0
            hourTimeSpanComponent.MaxValue = 23
            hourTimeSpanComponent.ShowUpDownButtons = False
            AddHandler hourTimeSpanComponent.ValueChanged, AddressOf hourTimeSpanComponent_ValueChanged
            AddHandler hourTimeSpanComponent.TextBoxItem.LostFocus, AddressOf TextBoxItem_LostFocus

            minuteTimeSpanComponent.MinValue = 0
            minuteTimeSpanComponent.DecimalPlaces = 0
            minuteTimeSpanComponent.MaxValue = 59
            minuteTimeSpanComponent.ShowUpDownButtons = False
            AddHandler minuteTimeSpanComponent.ValueChanged, AddressOf minuteTimeSpanComponent_ValueChanged
            AddHandler minuteTimeSpanComponent.TextBoxItem.LostFocus, AddressOf TextBoxItem_LostFocus

            secondTimeSpanComponent.MinValue = 0
            secondTimeSpanComponent.DecimalPlaces = 0
            secondTimeSpanComponent.MaxValue = 59
            secondTimeSpanComponent.ShowUpDownButtons = False
            AddHandler secondTimeSpanComponent.ValueChanged, AddressOf secondTimeSpanComponent_ValueChanged
            AddHandler secondTimeSpanComponent.TextBoxItem.LostFocus, AddressOf TextBoxItem_LostFocus

            millisecondTimeSpanComponent.MinValue = 0
            millisecondTimeSpanComponent.DecimalPlaces = 0
            millisecondTimeSpanComponent.MaxValue = 999
            millisecondTimeSpanComponent.ShowUpDownButtons = False
            AddHandler millisecondTimeSpanComponent.ValueChanged, AddressOf millisecondTimeSpanComponent_ValueChanged
            AddHandler millisecondTimeSpanComponent.TextBoxItem.LostFocus, AddressOf TextBoxItem_LostFocus

            AddHandler button.Click, AddressOf button_Click
            container.Children.Add(button)

            Me.Children.Add(container)
            Me.m_value = New TimeSpan(0, 0, 0, 0, 0)
        End Sub

        Private Sub TextBoxItem_LostFocus(sender As Object, e As EventArgs)
            Dim tb As RadTextBoxItem = TryCast(sender, RadTextBoxItem)
            If tb.Text = String.Empty Then
                tb.Text = "0"
            End If
        End Sub

        Private Sub millisecondTimeSpanComponent_ValueChanged(sender As Object, e As EventArgs)
            Dim el As RadSpinEditorElement = TryCast(sender, RadSpinEditorElement)
            Me.Value = New TimeSpan(Me.Value.Days, Me.Value.Hours, Me.Value.Minutes, Me.Value.Seconds, CInt(el.Value))
        End Sub

        Private Sub secondTimeSpanComponent_ValueChanged(sender As Object, e As EventArgs)
            Dim el As RadSpinEditorElement = TryCast(sender, RadSpinEditorElement)
            Me.Value = New TimeSpan(Me.Value.Days, Me.Value.Hours, Me.Value.Minutes, CInt(el.Value), Me.Value.Milliseconds)
        End Sub

        Private Sub minuteTimeSpanComponent_ValueChanged(sender As Object, e As EventArgs)
            Dim el As RadSpinEditorElement = TryCast(sender, RadSpinEditorElement)
            Me.Value = New TimeSpan(Me.Value.Days, Me.Value.Hours, CInt(el.Value), Me.Value.Seconds, Me.Value.Milliseconds)
        End Sub

        Private Sub hourTimeSpanComponent_ValueChanged(sender As Object, e As EventArgs)
            Dim el As RadSpinEditorElement = TryCast(sender, RadSpinEditorElement)
            Me.Value = New TimeSpan(Me.Value.Days, CInt(el.Value), Me.Value.Minutes, Me.Value.Seconds, Me.Value.Milliseconds)
        End Sub

        Private Sub dayTimeSpanComponent_ValueChanged(sender As Object, e As EventArgs)
            Dim el As RadSpinEditorElement = TryCast(sender, RadSpinEditorElement)
            Me.Value = New TimeSpan(CInt(el.Value), Me.Value.Hours, Me.Value.Minutes, Me.Value.Seconds, Me.Value.Milliseconds)
        End Sub

        Protected Overridable Function CreateDropDownForm() As RadDropDownMenu
            Dim popup As New RadDropDownMenu()
            popup.MinimumSize = Me.PopupSize
            popup.MaximumSize = Me.PopupSize
            Dim hostMenuItem As New RadMenuItem()
            popup.RollOverItemSelection = False
            hostMenuItem.MinSize = New System.Drawing.Size(0, Me.PopupSize.Height)
            hostMenuItem.MaxSize = hostMenuItem.MinSize
            m_timeSpanComponentsContainer.Orientation = Orientation.Horizontal
            m_timeSpanComponentsContainer.Children.Add(CreateTimeSpanComponent("Days", Me.DaysStep, Me.DaysItemsCount))
            m_timeSpanComponentsContainer.Children.Add(CreateTimeSpanComponent("Hours", Me.HoursStep, Me.HoursItemsCount))
            m_timeSpanComponentsContainer.Children.Add(CreateTimeSpanComponent("Minutes", Me.MinutesStep, Me.MinutesItemsCount))
            m_timeSpanComponentsContainer.Children.Add(CreateTimeSpanComponent("Seconds", Me.SecondsStep, Me.SecondsItemsCount))
            m_timeSpanComponentsContainer.Children.Add(CreateTimeSpanComponent("Miliseconds", Me.MilisecondsStep, Me.MilisecondsItemsCount))

            Dim closeButton As New RadButtonElement()
            closeButton.Text = "Close"
            closeButton.MinSize = New System.Drawing.Size(50, 20)
            AddHandler closeButton.Click, AddressOf closeButton_Click
            DockLayoutPanel.SetDock(closeButton, Telerik.WinControls.Layouts.Dock.Right)
            m_buttonsContainer.Children.Add(closeButton)

            Dim clearButton As New RadButtonElement()
            clearButton.Text = "Clear"
            clearButton.MinSize = New System.Drawing.Size(50, 20)
            AddHandler clearButton.Click, AddressOf clearButton_Click
            DockLayoutPanel.SetDock(clearButton, Telerik.WinControls.Layouts.Dock.Right)
            m_buttonsContainer.Children.Add(clearButton)

            Dim okButton As New RadButtonElement()
            okButton.Text = "OK"
            okButton.MinSize = New System.Drawing.Size(50, 20)
            AddHandler okButton.Click, AddressOf okButton_Click
            DockLayoutPanel.SetDock(okButton, Telerik.WinControls.Layouts.Dock.Left)

            m_buttonsContainer.Children.Add(okButton)
            m_buttonsContainer.LastChildFill = False

            Dim mainContainer As New StackLayoutPanel()
            mainContainer.Orientation = Orientation.Vertical
            mainContainer.Children.Add(m_timeSpanComponentsContainer)
            mainContainer.Children.Add(m_buttonsContainer)
            hostMenuItem.Children.Add(mainContainer)
            popup.Items.Add(hostMenuItem)
            AddHandler popup.PopupClosing, AddressOf popup_PopupClosing
            AddHandler popup.PopupOpened, AddressOf popup_PopupOpened
            Return popup
        End Function

        Private Sub popup_PopupOpened(sender As Object, args As EventArgs)
            InitializeTimeSpanComponents()
        End Sub

        Private Sub clearButton_Click(sender As Object, e As EventArgs)
            Me.Value = New TimeSpan()
        End Sub

        Private Sub closeButton_Click(sender As Object, e As EventArgs)
            shouldClose = True
            popup.ClosePopup(RadPopupCloseReason.Mouse)
            shouldClose = False
        End Sub

        Private Sub okButton_Click(sender As Object, e As EventArgs)
            Dim daysValue As Integer = If(Me.DaysView.SelectedIndex > 0, Integer.Parse(Me.DaysView.SelectedItem.Text), 0)
            Dim minutesValue As Integer = If(Me.MinutesView.SelectedIndex > 0, Integer.Parse(Me.MinutesView.SelectedItem.Text), 0)
            Dim hoursValue As Integer = If(Me.HoursView.SelectedIndex > 0, Integer.Parse(Me.HoursView.SelectedItem.Text), 0)
            Dim secondsValue As Integer = If(Me.SecondsView.SelectedIndex > 0, Integer.Parse(Me.SecondsView.SelectedItem.Text), 0)
            Dim milisecondsValue As Integer = If(Me.MilisecondsView.SelectedIndex > 0, Integer.Parse(Me.MilisecondsView.SelectedItem.Text), 0)

            Me.Value = New TimeSpan(daysValue, hoursValue, minutesValue, secondsValue, milisecondsValue)
            shouldClose = True
            popup.ClosePopup(RadPopupCloseReason.Mouse)
            shouldClose = False
        End Sub

        Public Property DaysStep() As Integer
            Get
                Return m_DaysStep
            End Get
            Set(value As Integer)
                m_DaysStep = value
            End Set
        End Property
        Private m_DaysStep As Integer
        Public Property DaysItemsCount() As Integer
            Get
                Return m_DaysItemsCount
            End Get
            Set(value As Integer)
                m_DaysItemsCount = value
            End Set
        End Property
        Private m_DaysItemsCount As Integer
        Public Property HoursStep() As Integer
            Get
                Return m_HoursStep
            End Get
            Set(value As Integer)
                m_HoursStep = value
            End Set
        End Property
        Private m_HoursStep As Integer
        Public Property HoursItemsCount() As Integer
            Get
                Return m_HoursItemsCount
            End Get
            Set(value As Integer)
                m_HoursItemsCount = value
            End Set
        End Property
        Private m_HoursItemsCount As Integer
        Public Property MinutesStep() As Integer
            Get
                Return m_MinutesStep
            End Get
            Set(value As Integer)
                m_MinutesStep = value
            End Set
        End Property
        Private m_MinutesStep As Integer
        Public Property MinutesItemsCount() As Integer
            Get
                Return m_MinutesItemsCount
            End Get
            Set(value As Integer)
                m_MinutesItemsCount = value
            End Set
        End Property
        Private m_MinutesItemsCount As Integer
        Public Property SecondsStep() As Integer
            Get
                Return m_SecondsStep
            End Get
            Set(value As Integer)
                m_SecondsStep = value
            End Set
        End Property
        Private m_SecondsStep As Integer
        Public Property SecondsItemsCount() As Integer
            Get
                Return m_SecondsItemsCount
            End Get
            Set(value As Integer)
                m_SecondsItemsCount = value
            End Set
        End Property
        Private m_SecondsItemsCount As Integer
        Public Property MilisecondsStep() As Integer
            Get
                Return m_MilisecondsStep
            End Get
            Set(value As Integer)
                m_MilisecondsStep = value
            End Set
        End Property
        Private m_MilisecondsStep As Integer
        Public Property MilisecondsItemsCount() As Integer
            Get
                Return m_MilisecondsItemsCount
            End Get
            Set(value As Integer)
                m_MilisecondsItemsCount = value
            End Set
        End Property
        Private m_MilisecondsItemsCount As Integer
        Public ReadOnly Property TimeSpanComponentsContainer() As StackLayoutPanel
            Get
                Return m_timeSpanComponentsContainer
            End Get
        End Property
        Public ReadOnly Property ButtonsContainer() As DockLayoutPanel
            Get
                Return m_buttonsContainer
            End Get
        End Property
        Public ReadOnly Property DaysView() As RadListViewElement
            Get
                Return DirectCast(Me.m_timeSpanComponentsContainer.Children(0).Children(1), RadListViewElement)
            End Get
        End Property
        Public ReadOnly Property HoursView() As RadListViewElement
            Get
                Return DirectCast(Me.m_timeSpanComponentsContainer.Children(1).Children(1), RadListViewElement)
            End Get
        End Property
        Public ReadOnly Property MinutesView() As RadListViewElement
            Get
                Return DirectCast(Me.m_timeSpanComponentsContainer.Children(2).Children(1), RadListViewElement)
            End Get
        End Property
        Public ReadOnly Property SecondsView() As RadListViewElement
            Get
                Return DirectCast(Me.m_timeSpanComponentsContainer.Children(3).Children(1), RadListViewElement)
            End Get
        End Property
        Public ReadOnly Property MilisecondsView() As RadListViewElement
            Get
                Return DirectCast(Me.m_timeSpanComponentsContainer.Children(4).Children(1), RadListViewElement)
            End Get
        End Property

        Private Function CreateTimeSpanComponent(headerText As String, [step] As Integer, count As Integer) As RadElement
            Dim timeSpanComponentContainer As New StackLayoutPanel()
            timeSpanComponentContainer.Orientation = Orientation.Vertical
            Dim header As New LightVisualElement()
            header.Text = headerText
            header.TextAlignment = ContentAlignment.MiddleLeft
            timeSpanComponentContainer.Children.Add(header)
            Dim listView As New RadListViewElement()
            listView.MaxSize = New System.Drawing.Size(Me.PopupSize.Width / 5 - 10, Me.PopupSize.Height - 45)

            AddHandler listView.ItemMouseDown, AddressOf listView_ItemMouseDown
            Dim i As Integer = 0
            While i <= count * [step]
                Dim item As New RadListDataItem((i).ToString())
                listView.Items.Add(item)
                i += [step]
            End While
            listView.ItemSize = New System.Drawing.Size(listView.MaxSize.Width - 20, 20)
            timeSpanComponentContainer.Children.Add(listView)
            Return timeSpanComponentContainer
        End Function

        Private Function GetSelectedIndex(headerText As String, listView As RadListViewElement) As Integer
            Dim index As Integer = 0
            Dim pattern As String = String.Empty
            Select Case headerText
                Case "Days"
                    pattern = Me.Value.Days.ToString()
                    Exit Select
                Case "Hours"
                    pattern = Me.Value.Hours.ToString()
                    Exit Select
                Case "Minutes"
                    pattern = Me.Value.Minutes.ToString()
                    Exit Select
                Case "Seconds"
                    pattern = Me.Value.Seconds.ToString()
                    Exit Select
                Case "Miliseconds"
                    pattern = Me.Value.Milliseconds.ToString()
                    Exit Select
                Case Else
                    Exit Select
            End Select

            For Each item As ListViewDataItem In listView.Items
                If item.Text = pattern Then
                    index = listView.Items.IndexOf(item)
                    Exit For
                End If
            Next
            Return index
        End Function

        Private Sub listView_ItemMouseDown(sender As Object, e As ListViewItemMouseEventArgs)
            Dim el As RadListViewElement = TryCast(sender, RadListViewElement)
            el.SelectedItem = e.Item
        End Sub

        Private Sub popup_PopupClosing(sender As Object, args As RadPopupClosingEventArgs)
            args.Cancel = Not shouldClose
        End Sub

        Private Sub button_Click(sender As Object, e As EventArgs)
            popup.Show(Me.ElementTree.Control)
        End Sub

        Public Property PopupSize() As Size
            Get
                Return m_PopupSize
            End Get
            Set(value As Size)
                m_PopupSize = value
            End Set
        End Property
        Private m_PopupSize As Size

        Public Property Separator() As String
            Get
                Return m_Separator
            End Get
            Set(value As String)
                m_Separator = value
            End Set
        End Property
        Private m_Separator As String

        Public Property Value() As TimeSpan
            Get
                Return m_value
            End Get
            Set(value As TimeSpan)
                Me.m_value = value
                InitializeTimeSpanComponents()
                OnValueChanged(New ValueEventArgs(m_value))
            End Set
        End Property

        Private Sub InitializeTimeSpanComponents()
            Me.dayTimeSpanComponent.Value = Me.m_value.Days
            Me.hourTimeSpanComponent.Value = Me.m_value.Hours
            Me.minuteTimeSpanComponent.Value = Me.m_value.Minutes
            Me.secondTimeSpanComponent.Value = Me.m_value.Seconds
            Me.millisecondTimeSpanComponent.Value = Me.m_value.Milliseconds

            DaysView.SelectedIndex = GetSelectedIndex("Days", DaysView)
            HoursView.SelectedIndex = GetSelectedIndex("Hours", HoursView)
            MinutesView.SelectedIndex = GetSelectedIndex("Minutes", MinutesView)
            SecondsView.SelectedIndex = GetSelectedIndex("Seconds", SecondsView)
            MilisecondsView.SelectedIndex = GetSelectedIndex("Miliseconds", MilisecondsView)

            DaysView.ViewElement.Scroller.ScrollToItem(DaysView.SelectedItem)
            HoursView.ViewElement.Scroller.ScrollToItem(HoursView.SelectedItem)
            MinutesView.ViewElement.Scroller.ScrollToItem(MinutesView.SelectedItem)
            SecondsView.ViewElement.Scroller.ScrollToItem(SecondsView.SelectedItem)
            MilisecondsView.ViewElement.Scroller.ScrollToItem(MilisecondsView.SelectedItem)
        End Sub

        Protected Overrides Function ArrangeOverride(finalSize As SizeF) As SizeF
            Dim size As SizeF = MyBase.ArrangeOverride(finalSize)

            Dim rect As RectangleF = GetClientRectangle(finalSize)

            Dim previousX As Single = 0
            Dim width As Integer = 0
            For Each element As RadElement In Me.Children(0).Children
                If TypeOf element Is RadLabelElement Then
                    width = 10
                Else
                    width = 25
                End If


                Dim elementRect As New RectangleF(previousX, 1, width, 20)
                element.Arrange(elementRect)
                previousX += elementRect.Width
            Next
            Me.Children(0).Arrange(rect)

            Return size
        End Function

    End Class

    Public Class ValueEventArgs
        Inherits EventArgs
        Private m_value As TimeSpan

        Public ReadOnly Property Value() As TimeSpan
            Get
                Return Me.m_value
            End Get
        End Property
        Public Sub New(newValue As TimeSpan)
            Me.m_value = newValue
        End Sub
    End Class
End Class
